#!/bin/bash

#  This script is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2 as
#  published by the Free Software Foundation.
#
#  See the COPYING and AUTHORS files for more details.

# Read in library functions
if [ "$(type -t patch_file_name)" != function ]
then
	if ! [ -r /usr/share/quilt/lib/patchfns ]
	then
		echo "Cannot read library /usr/share/quilt/lib/patchfns" >&2
		exit 1
	fi
	. /usr/share/quilt/lib/patchfns
fi

usage()
{
	echo "Usage: quilt new {patchname}"
	if [ x$1 = x-h ]
	then
		cat <<EOF

Create a new patch with the specified file name, and insert
it after the topmost patch in the patch series file.

EOF
		exit 0
	else
		exit 1
	fi
}

options=`getopt -o h -- "$@"`

if [ $? -ne 0 ]
then
	usage
fi

eval set -- "$options"

while true
do
	case "$1" in
	-h)
		usage -h ;;
	--)
		shift
		break ;;
	esac
done

if [ $# -ne 1 ]
then
	usage
fi

patch_file=$(echo $1 | sed -e 's:^'"$P"'patches/::')
patch=$(stripit $patch_file)

if patch_in_series $patch
then
	echo "Patch $patch exists already"
	exit 1
fi

mkdir -p $(dirname $(pc_file_name $patch))
rm -f $(pc_file_name $patch)

if ! insert_in_series $patch_file || \
   ! add_to_db $patch
then
	echo "Failed to create patch $patch"
	exit 1
else
	echo "Patch $patch is now on top"
fi
